# -*- Mode: shell-script; -*-
autoload -Uz add-zsh-hook
autoload -Uz compinit
autoload -U colors
autoload -Uz vcs_info

# Autoload zsh functions.
fpath=($HOME/.zsh/functions $fpath)
autoload -U $HOME/.zsh/functions/*(:t)

# Setup variables
HISTFILE=$HOME/.zsh/histfile
HISTSIZE=1000
SAVEHIST=1000
LESSCMD="/usr/bin/less -FXRS"

export LESS_TERMCAP_mb=$'\e[1;37m'
export LESS_TERMCAP_md=$'\e[1;37m'
export LESS_TERMCAP_me=$'\e[0m'
export LESS_TERMCAP_se=$'\e[0m'
export LESS_TERMCAP_so=$'\e[1;47;30m'
export LESS_TERMCAP_ue=$'\e[0m'
export LESS_TERMCAP_us=$'\e[0;36m'
export PAGER=$LESSCMD

# Aliases
alias alpine="alpine -p ""{imap.gmail.com/ssl/user=tom.willemsen@archlinux.us}remote_pinerc"""
alias evolus-pencil="/usr/lib/evolus-pencil-svn/evolus-pencil.sh"
alias grep="grep --color=always"
alias less=$LESSCMD
alias ls="ls -F --color=always"
alias mysql="mysql --pager"

# Suffix aliases
alias -s pdf="zathura"
alias -s xls="libreoffice"

setopt notify
setopt PROMPT_SUBST             # Allow for functions in the prompt
setopt EXTENDED_GLOB

zstyle :compinstall filename '$HOME/.zshrc'

# Enable auto-execution of functions
typeset -ga preexec_functions
typeset -ga precmd_functions
typeset -ga chpwd_functions

add-zsh-hook preexec preexec_update_vars
add-zsh-hook precmd precmd_update_git_vars
add-zsh-hook precmd precmd_update_updates
add-zsh-hook precmd precmd_maybe_festival
add-zsh-hook precmd vcs_info
add-zsh-hook chpwd chpwd_update_git_vars

zstyle ':vcs_info:*' actionformats '%B%F{1}%a%f%%b (%F{3}%s%f) %F{5}%r%f:%F{4}%b%f %F{2}%S%f'
zstyle ':vcs_info:*' enable bzr git hg svn
zstyle ':vcs_info:*' formats '(%F{3}%s%f) %F{5}%r%f:%F{4}%b%f %F{2}%S%f'
zstyle ':vcs_info:*' nvcsformats '%F{2}%~%f'
zstyle ':vcs_info:bzr:*' branchformat '%b'

# Set the prompt.
PROMPT='${vcs_info_msg_0_}
%B%F{6}%m%b%f %B%(?.%F{2}+.%F{1}-)%b> '

# Set terminal name to current running application
case $TERM in
    rxvt*)
        precmd () { print -Pn "\e]0;%~\a" }
        preexec () { print -Pn "\e]0;$1\a" }
        ;;
esac

add-to-list PATH "$HOME/usr/bin"
add-to-list PATH "/usr/local/clark/bin" t

add-to-list INFOPATH "$HOME/documents/info"
add-to-list INFOPATH "$HOME/.emacs.d/vendor-lisp/org/doc"
add-to-list INFOPATH "/usr/local/clark/share/info" t

# Set terminal keys
bindkey "\e[1~"  beginning-of-line
bindkey "\e[4~"  end-of-line
bindkey "\e[5~"  beginning-of-history
bindkey "\e[6~"  end-of-history
bindkey "\e[3~"  delete-char
bindkey "\e[2~"  quoted-insert
bindkey "\e[5C"  forward-word
bindkey "\e0c"   emacs-forward-word
bindkey "\e[5D"  backward-word
bindkey "\e0d"   emacs-backward-word
bindkey "\e\e[C" forward-word
bindkey "\e\e[D" backward-word
## for rxvt
bindkey "\e[8~"  end-of-line
bindkey "\e[7~"  beginning-of-line
## for non RH/Debian xterm, can't hurt for RH/Debian xterm
bindkey "\e0H"   beginning-of-line
bindkey "\e0F"   end-of-line
## for freebsd console
bindkey "\e[H"   beginning-of-line
bindkey "\e[F"   end-of-line

bindkey "^W" backward-delete-char

# Show syntax highlighting when we're not running in emacs
if [ -z $EMACS ]; then
    source $HOME/.zsh/syntax-highlighting/zsh-syntax-highlighting.zsh

    ZSH_HIGHLIGHT_STYLES[double-hyphen-option]='fg=blue'
    ZSH_HIGHLIGHT_STYLES[single-hyphen-option]='fg=blue'
fi

compinit
colors                          # Initialize colors.
